Package com.google.gwt.dom.client

## Class DOMImpl

- java.lang.Object
- - com.google.gwt.dom.client.DOMImpl

- Direct Known Subclasses:
    `DOMImplStandard`

      abstract class DOMImpl
      extends java.lang.Object

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `(package private) static DOMImpl` | `impl` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DOMImpl()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `buttonClick​(ButtonElement button)` |
    `ButtonElement` | `createButtonElement​(Document doc, java.lang.String type)` |
    `InputElement` | `createCheckInputElement​(Document doc)` |
    `Element` | `createElement​(Document doc, java.lang.String tag)` |
    `abstract NativeEvent` | `createHtmlEvent​(Document doc, java.lang.String type, boolean canBubble, boolean cancelable)` |
    `InputElement` | `createInputElement​(Document doc, java.lang.String type)` |
    `abstract InputElement` | `createInputRadioElement​(Document doc, java.lang.String name)` |
    `abstract NativeEvent` | `createKeyCodeEvent​(Document document, java.lang.String type, boolean ctrlKey, boolean altKey, boolean shiftKey, boolean metaKey, int keyCode)` |
    `abstract NativeEvent` | `createKeyEvent​(Document doc, java.lang.String type, boolean canBubble, boolean cancelable, boolean ctrlKey, boolean altKey, boolean shiftKey, boolean metaKey, int keyCode, int charCode)` | Deprecated.
    `abstract NativeEvent` | `createKeyPressEvent​(Document document, boolean ctrlKey, boolean altKey, boolean shiftKey, boolean metaKey, int charCode)` |
    `abstract NativeEvent` | `createMouseEvent​(Document doc, java.lang.String type, boolean canBubble, boolean cancelable, int detail, int screenX, int screenY, int clientX, int clientY, boolean ctrlKey, boolean altKey, boolean shiftKey, boolean metaKey, int button, Element relatedTarget)` |
    `ScriptElement` | `createScriptElement​(Document doc, java.lang.String source)` |
    `void` | `cssClearOpacity​(Style style)` |
    `java.lang.String` | `cssFloatPropertyName()` |
    `void` | `cssSetOpacity​(Style style, double value)` |
    `abstract void` | `dispatchEvent​(Element target, NativeEvent evt)` |
    `boolean` | `eventGetAltKey​(NativeEvent evt)` |
    `int` | `eventGetButton​(NativeEvent evt)` |
    `abstract int` | `eventGetCharCode​(NativeEvent evt)` |
    `int` | `eventGetClientX​(NativeEvent evt)` |
    `int` | `eventGetClientY​(NativeEvent evt)` |
    `boolean` | `eventGetCtrlKey​(NativeEvent evt)` |
    `EventTarget` | `eventGetCurrentTarget​(NativeEvent event)` |
    `int` | `eventGetKeyCode​(NativeEvent evt)` |
    `boolean` | `eventGetMetaKey​(NativeEvent evt)` |
    `int` | `eventGetMouseWheelVelocityY​(NativeEvent evt)` |
    `abstract EventTarget` | `eventGetRelatedTarget​(NativeEvent nativeEvent)` |
    `double` | `eventGetRotation​(NativeEvent evt)` |
    `double` | `eventGetScale​(NativeEvent evt)` |
    `int` | `eventGetScreenX​(NativeEvent evt)` |
    `int` | `eventGetScreenY​(NativeEvent evt)` |
    `boolean` | `eventGetShiftKey​(NativeEvent evt)` |
    `abstract EventTarget` | `eventGetTarget​(NativeEvent evt)` |
    `java.lang.String` | `eventGetType​(NativeEvent evt)` |
    `abstract void` | `eventPreventDefault​(NativeEvent evt)` |
    `void` | `eventSetKeyCode​(NativeEvent evt, char key)` |
    `void` | `eventStopPropagation​(NativeEvent evt)` |
    `abstract java.lang.String` | `eventToString​(NativeEvent evt)` |
    `int` | `getAbsoluteLeft​(Element elem)` |
    `int` | `getAbsoluteTop​(Element elem)` |
    `java.lang.String` | `getAttribute​(Element elem, java.lang.String name)` |
    `int` | `getBodyOffsetLeft​(Document doc)` |
    `int` | `getBodyOffsetTop​(Document doc)` |
    `JsArray<Touch>` | `getChangedTouches​(NativeEvent evt)` |
    `(package private) Element` | `getDocumentScrollingElement​(Document doc)` |
    `Element` | `getFirstChildElement​(Element elem)` |
    `java.lang.String` | `getInnerHTML​(Element elem)` |
    `java.lang.String` | `getInnerText​(Element node)` |
    `Element` | `getNextSiblingElement​(Element elem)` |
    `int` | `getNodeType​(Node node)` |
    `java.lang.String` | `getNumericStyleProperty​(Style style, java.lang.String name)` | Returns a numeric style property (such as zIndex) that may need to be coerced to a string.
    `Element` | `getParentElement​(Node node)` |
    `Element` | `getPreviousSiblingElement​(Element elem)` |
    `int` | `getScrollLeft​(Document doc)` |
    `int` | `getScrollLeft​(Element elem)` |
    `int` | `getScrollTop​(Document doc)` |
    `java.lang.String` | `getStyleProperty​(Style style, java.lang.String name)` |
    `int` | `getTabIndex​(Element elem)` |
    `java.lang.String` | `getTagName​(Element elem)` |
    `JsArray<Touch>` | `getTargetTouches​(NativeEvent evt)` |
    `JsArray<Touch>` | `getTouches​(NativeEvent evt)` |
    `boolean` | `hasAttribute​(Element elem, java.lang.String name)` |
    `abstract boolean` | `isOrHasChild​(Node parent, Node child)` |
    `void` | `scrollIntoView​(Element elem)` |
    `void` | `selectAdd​(SelectElement select, OptionElement option, OptionElement before)` |
    `void` | `selectClear​(SelectElement select)` |
    `int` | `selectGetLength​(SelectElement select)` |
    `NodeList<OptionElement>` | `selectGetOptions​(SelectElement select)` |
    `void` | `selectRemoveOption​(SelectElement select, int index)` |
    `void` | `setDraggable​(Element elem, java.lang.String draggable)` |
    `void` | `setInnerText​(Element elem, java.lang.String text)` |
    `void` | `setScrollLeft​(Document doc, int left)` |
    `void` | `setScrollLeft​(Element elem, int left)` |
    `void` | `setScrollTop​(Document doc, int top)` |
    `protected static int` | `toInt32​(double val)` | Fast helper method to convert small doubles to 32-bit int.
    `java.lang.String` | `toString​(Element elem)` |
    `int` | `touchGetClientX​(Touch touch)` |
    `int` | `touchGetClientY​(Touch touch)` |
    `int` | `touchGetIdentifier​(Touch touch)` |
    `int` | `touchGetPageX​(Touch touch)` |
    `int` | `touchGetPageY​(Touch touch)` |
    `int` | `touchGetScreenX​(Touch touch)` |
    `int` | `touchGetScreenY​(Touch touch)` |
    `EventTarget` | `touchGetTarget​(Touch touch)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### impl

          static final DOMImpl impl

  - ### Constructor Detail

    - #### DOMImpl

          DOMImpl()

  - ### Method Detail

    - #### toInt32

          protected static int toInt32​(double val)

      Fast helper method to convert small doubles to 32-bit int.

      Note: you should be aware that this uses JavaScript rounding and thus does NOT provide the same semantics as `int b = (int) someDouble;`. In particular, if x is outside the range [-2^31,2^31), then toInt32(x) would return a value equivalent to x modulo 2^32, whereas (int) x would evaluate to either MIN_INT or MAX_INT.

    - #### buttonClick

          public void buttonClick​(ButtonElement button)

    - #### createButtonElement

          public ButtonElement createButtonElement​(Document doc,
                                                   java.lang.String type)

    - #### createCheckInputElement

          public InputElement createCheckInputElement​(Document doc)

    - #### createElement

          public Element createElement​(Document doc,
                                       java.lang.String tag)

    - #### createHtmlEvent

          public abstract NativeEvent createHtmlEvent​(Document doc,
                                                      java.lang.String type,
                                                      boolean canBubble,
                                                      boolean cancelable)

    - #### createInputElement

          public InputElement createInputElement​(Document doc,
                                                 java.lang.String type)

    - #### createInputRadioElement

          public abstract InputElement createInputRadioElement​(Document doc,
                                                               java.lang.String name)

    - #### createKeyCodeEvent

          public abstract NativeEvent createKeyCodeEvent​(Document document,
                                                         java.lang.String type,
                                                         boolean ctrlKey,
                                                         boolean altKey,
                                                         boolean shiftKey,
                                                         boolean metaKey,
                                                         int keyCode)

    - #### createKeyEvent

          @Deprecated
          public abstract NativeEvent createKeyEvent​(Document doc,
                                                     java.lang.String type,
                                                     boolean canBubble,
                                                     boolean cancelable,
                                                     boolean ctrlKey,
                                                     boolean altKey,
                                                     boolean shiftKey,
                                                     boolean metaKey,
                                                     int keyCode,
                                                     int charCode)

      Deprecated.

    - #### createKeyPressEvent

          public abstract NativeEvent createKeyPressEvent​(Document document,
                                                          boolean ctrlKey,
                                                          boolean altKey,
                                                          boolean shiftKey,
                                                          boolean metaKey,
                                                          int charCode)

    - #### createMouseEvent

          public abstract NativeEvent createMouseEvent​(Document doc,
                                                       java.lang.String type,
                                                       boolean canBubble,
                                                       boolean cancelable,
                                                       int detail,
                                                       int screenX,
                                                       int screenY,
                                                       int clientX,
                                                       int clientY,
                                                       boolean ctrlKey,
                                                       boolean altKey,
                                                       boolean shiftKey,
                                                       boolean metaKey,
                                                       int button,
                                                       Element relatedTarget)

    - #### createScriptElement

          public ScriptElement createScriptElement​(Document doc,
                                                   java.lang.String source)

    - #### cssClearOpacity

          public void cssClearOpacity​(Style style)

    - #### cssFloatPropertyName

          public java.lang.String cssFloatPropertyName()

    - #### cssSetOpacity

          public void cssSetOpacity​(Style style,
                                    double value)

    - #### dispatchEvent

          public abstract void dispatchEvent​(Element target,
                                             NativeEvent evt)

    - #### eventGetAltKey

          public boolean eventGetAltKey​(NativeEvent evt)

    - #### eventGetButton

          public int eventGetButton​(NativeEvent evt)

    - #### eventGetCharCode

          public abstract int eventGetCharCode​(NativeEvent evt)

    - #### eventGetClientX

          public int eventGetClientX​(NativeEvent evt)

    - #### eventGetClientY

          public int eventGetClientY​(NativeEvent evt)

    - #### eventGetCtrlKey

          public boolean eventGetCtrlKey​(NativeEvent evt)

    - #### eventGetCurrentTarget

          public EventTarget eventGetCurrentTarget​(NativeEvent event)

    - #### eventGetKeyCode

          public final int eventGetKeyCode​(NativeEvent evt)

    - #### eventGetMetaKey

          public boolean eventGetMetaKey​(NativeEvent evt)

    - #### eventGetMouseWheelVelocityY

          public int eventGetMouseWheelVelocityY​(NativeEvent evt)

    - #### eventGetRelatedTarget

          public abstract EventTarget eventGetRelatedTarget​(NativeEvent nativeEvent)

    - #### eventGetRotation

          public double eventGetRotation​(NativeEvent evt)

    - #### eventGetScale

          public double eventGetScale​(NativeEvent evt)

    - #### eventGetScreenX

          public int eventGetScreenX​(NativeEvent evt)

    - #### eventGetScreenY

          public int eventGetScreenY​(NativeEvent evt)

    - #### eventGetShiftKey

          public boolean eventGetShiftKey​(NativeEvent evt)

    - #### eventGetTarget

          public abstract EventTarget eventGetTarget​(NativeEvent evt)

    - #### eventGetType

          public final java.lang.String eventGetType​(NativeEvent evt)

    - #### eventPreventDefault

          public abstract void eventPreventDefault​(NativeEvent evt)

    - #### eventSetKeyCode

          public void eventSetKeyCode​(NativeEvent evt,
                                      char key)

    - #### eventStopPropagation

          public void eventStopPropagation​(NativeEvent evt)

    - #### eventToString

          public abstract java.lang.String eventToString​(NativeEvent evt)

    - #### getAbsoluteLeft

          public int getAbsoluteLeft​(Element elem)

    - #### getAbsoluteTop

          public int getAbsoluteTop​(Element elem)

    - #### getAttribute

          public java.lang.String getAttribute​(Element elem,
                                               java.lang.String name)

    - #### getBodyOffsetLeft

          public int getBodyOffsetLeft​(Document doc)

    - #### getBodyOffsetTop

          public int getBodyOffsetTop​(Document doc)

    - #### getChangedTouches

          public JsArray<Touch> getChangedTouches​(NativeEvent evt)

    - #### getFirstChildElement

          public Element getFirstChildElement​(Element elem)

    - #### getInnerHTML

          public java.lang.String getInnerHTML​(Element elem)

    - #### getInnerText

          public java.lang.String getInnerText​(Element node)

    - #### getNextSiblingElement

          public Element getNextSiblingElement​(Element elem)

    - #### getNodeType

          public int getNodeType​(Node node)

    - #### getNumericStyleProperty

          public java.lang.String getNumericStyleProperty​(Style style,
                                                          java.lang.String name)

      Returns a numeric style property (such as zIndex) that may need to be coerced to a string.

    - #### getParentElement

          public Element getParentElement​(Node node)

    - #### getPreviousSiblingElement

          public Element getPreviousSiblingElement​(Element elem)

    - #### getScrollLeft

          public int getScrollLeft​(Document doc)

    - #### getScrollLeft

          public int getScrollLeft​(Element elem)

    - #### getScrollTop

          public int getScrollTop​(Document doc)

    - #### getStyleProperty

          public java.lang.String getStyleProperty​(Style style,
                                                   java.lang.String name)

    - #### getTabIndex

          public int getTabIndex​(Element elem)

    - #### getTagName

          public java.lang.String getTagName​(Element elem)

    - #### getTargetTouches

          public JsArray<Touch> getTargetTouches​(NativeEvent evt)

    - #### getTouches

          public JsArray<Touch> getTouches​(NativeEvent evt)

    - #### hasAttribute

          public boolean hasAttribute​(Element elem,
                                      java.lang.String name)

    - #### isOrHasChild

          public abstract boolean isOrHasChild​(Node parent,
                                               Node child)

    - #### scrollIntoView

          public void scrollIntoView​(Element elem)

    - #### selectAdd

          public void selectAdd​(SelectElement select,
                                OptionElement option,
                                OptionElement before)

    - #### selectClear

          public void selectClear​(SelectElement select)

    - #### selectGetLength

          public int selectGetLength​(SelectElement select)

    - #### selectGetOptions

          public NodeList<OptionElement> selectGetOptions​(SelectElement select)

    - #### selectRemoveOption

          public void selectRemoveOption​(SelectElement select,
                                         int index)

    - #### setDraggable

          public void setDraggable​(Element elem,
                                   java.lang.String draggable)

    - #### setInnerText

          public void setInnerText​(Element elem,
                                   java.lang.String text)

    - #### setScrollLeft

          public void setScrollLeft​(Document doc,
                                    int left)

    - #### setScrollLeft

          public void setScrollLeft​(Element elem,
                                    int left)

    - #### setScrollTop

          public void setScrollTop​(Document doc,
                                   int top)

    - #### toString

          public java.lang.String toString​(Element elem)

    - #### getDocumentScrollingElement

          Element getDocumentScrollingElement​(Document doc)

    - #### touchGetClientX

          public int touchGetClientX​(Touch touch)

    - #### touchGetClientY

          public int touchGetClientY​(Touch touch)

    - #### touchGetIdentifier

          public int touchGetIdentifier​(Touch touch)

    - #### touchGetPageX

          public int touchGetPageX​(Touch touch)

    - #### touchGetPageY

          public int touchGetPageY​(Touch touch)

    - #### touchGetScreenX

          public int touchGetScreenX​(Touch touch)

    - #### touchGetScreenY

          public int touchGetScreenY​(Touch touch)

    - #### touchGetTarget

          public EventTarget touchGetTarget​(Touch touch)